
#include "ConfigManager.h"



ConfigManager::~ConfigManager()
{
	Clear();
}


bool ConfigManager::Initialize()
{
	FileReader configReader;

	try{
		if(!configReader.Open("config.ini", FileReader::ASCII))
			return false;
	}

	catch (IOException& ex)
	{	// set params telling "where" actaully it caused exception
		ex.SetFileName (__FILE__);
		ex.SetLineNum (__LINE__);
		ex.SetExceptionMsg (ex.GetExceptionMsg() + " Config file not opened sucessfully.");
		return false;
		throw; // re-throw the same exception object
	}

	string fieldName, fieldValue;

	try
	{
		while (configReader.EoF () == false)
		{
			if (configReader.GetLine (fieldName, 64, '=') == true)
			{
				Trim (fieldName);

				if (configReader.EoF () == false &&
						configReader.GetLine (fieldValue, 512, '\n') == true)
				{
					
					Trim(fieldValue);
					if (fieldName.compare ("NFDfilepath") == 0)
						NFDfilepath = fieldValue;
					else if (fieldName.compare ("NFCfilepath") == 0)
						NFCfilepath = fieldValue;
					else if (fieldName.compare ("NFKDfilepath") == 0)
						NFKDfilepath = fieldValue;
				}
			}
		}

		configReader.Close();
	}
	catch (IOException& ex)
	{
		// set params telling "where" actaully it caused exception
		ex.SetFileName (__FILE__);
		ex.SetLineNum (__LINE__);
		ex.SetExceptionMsg (ex.GetExceptionMsg() + " Config file reading problem occurred.");
		throw; // re-throw the same exception object
	}
	
	return true;	
}



void ConfigManager::Clear()
{
	NFCfilepath.erase();
	NFDfilepath.erase();
	NFKDfilepath.erase();

}