
#ifndef FILE_READER_H
#define FILE_READER_H

#include <string>
#include <fstream>
using namespace std;

//#include "uleGlobal.h"
//#include "Structs.h"
#include "Utility.h"
#include "OUDLEException.h"

class FileReader {
// friend functions
	//template <class Type>
//	friend void operator >> (FileReader& fr, unsigned short&/*Type&*/ i)
//	{
//		fr.ifsReader >> i;
//		return;// fr;
//	}

public:
	enum CODE {UNI, ASCII};

private:

	// data members
	ifstream ifsReader;
	bool bFileOpened;
	CODE characterSet;

public:

	// interface
	FileReader ();
	~FileReader ();
	static bool DoesExist(const char* cFileNamePtr);
	bool Open (const char* cFileNamePtr, CODE characterSet = FileReader::ASCII);
	bool Read (string& strBuffer, int intNumCh);
	bool Read (wstring& strBuffer, int intNumCh);
	bool Read (char* buf, int size);
	bool Read (wchar_t* buf, int size);
	bool Read (char* buf, int from, int size);
	bool GetLine (string& sBuffer, int intNumCh, char cDelim);
	bool GetLine (wstring& wsBuffer, int intNumCh, wchar_t wcDelim);
	bool UngetAsciiCharacters(int intNumCh);
	bool UngetUnicodeCharacters(int intNumCh);
	bool SeekG (int loc);
	int FileSize ();
	void Close ();
	bool EoF ();

};

#endif
