#ifndef OUDLEEXCEPTION_H
#define OUDLEEXCEPTION_H

#include <string>
#include <cstdlib>
using namespace std;

#include "Utility.h"

//#define STRINGS_COUNT 20




class OUDLEException {

	string FileName;
	int LineNum;
	int ErrCode;
	string ExceptionMsg;
	//const string errorStrings[STRINGS_COUNT];

public:
	OUDLEException (string fileName, int lineNum, int errCode, string exceptMsg);
	string GetFileName();
	int GetLineNum();
	int GetErrorCode();
	string GetErrorString();
	string GetExceptionMsg();
	void SetFileName(string s);
	void SetLineNum(int ln);
	void SetErrorCode(int c);
	void SetExceptionMsg(string s);
	string GetFormatedExceptionMessage();
};

class IOException : public OUDLEException {
public:
	IOException (string fileName, int lineNum, int errCode, string exceptMsg);
};


class InvalidFormatException : public OUDLEException {
public:
	InvalidFormatException (string fileName, int lineNum, int errCode, string exceptMsg);
};


class MemoryAllocationException : public OUDLEException {
public:
	MemoryAllocationException (string fileName, int lineNum, int errCode, string exceptMsg);
};


class OutOfBoundException : public OUDLEException {
public:
	OutOfBoundException (string fileName, int lineNum, int errCode, string exceptMsg);
};





#endif
